/* VPNMenuItem.c generated by valac 0.38.10, the Vala compiler
 * generated from VPNMenuItem.vala, do not modify */

/*-
 * Copyright (c) 2015-2018 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <NetworkManager.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>


#define NETWORK_TYPE_VPN_MENU_ITEM (network_vpn_menu_item_get_type ())
#define NETWORK_VPN_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem))
#define NETWORK_VPN_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItemClass))
#define NETWORK_IS_VPN_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_TYPE_VPN_MENU_ITEM))
#define NETWORK_IS_VPN_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_TYPE_VPN_MENU_ITEM))
#define NETWORK_VPN_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItemClass))

typedef struct _NetworkVPNMenuItem NetworkVPNMenuItem;
typedef struct _NetworkVPNMenuItemClass NetworkVPNMenuItemClass;
typedef struct _NetworkVPNMenuItemPrivate NetworkVPNMenuItemPrivate;

#define NETWORK_TYPE_STATE (network_state_get_type ())
enum  {
	NETWORK_VPN_MENU_ITEM_0_PROPERTY,
	NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY,
	NETWORK_VPN_MENU_ITEM_STATE_PROPERTY,
	NETWORK_VPN_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	NETWORK_VPN_MENU_ITEM_USER_ACTION_SIGNAL,
	NETWORK_VPN_MENU_ITEM_NUM_SIGNALS
};
static guint network_vpn_menu_item_signals[NETWORK_VPN_MENU_ITEM_NUM_SIGNALS] = {0};

struct _NetworkVPNMenuItem {
	GtkListBoxRow parent_instance;
	NetworkVPNMenuItemPrivate * priv;
};

struct _NetworkVPNMenuItemClass {
	GtkListBoxRowClass parent_class;
};

typedef enum  {
	NETWORK_STATE_DISCONNECTED,
	NETWORK_STATE_WIRED_UNPLUGGED,
	NETWORK_STATE_CONNECTED_WIRED,
	NETWORK_STATE_CONNECTED_VPN,
	NETWORK_STATE_CONNECTED_MOBILE,
	NETWORK_STATE_CONNECTED_WIFI,
	NETWORK_STATE_CONNECTED_WIFI_WEAK,
	NETWORK_STATE_CONNECTED_WIFI_OK,
	NETWORK_STATE_CONNECTED_WIFI_GOOD,
	NETWORK_STATE_CONNECTED_WIFI_EXCELLENT,
	NETWORK_STATE_CONNECTING_WIFI,
	NETWORK_STATE_CONNECTING_WIRED,
	NETWORK_STATE_CONNECTING_MOBILE,
	NETWORK_STATE_CONNECTING_VPN,
	NETWORK_STATE_FAILED_WIRED,
	NETWORK_STATE_FAILED_WIFI,
	NETWORK_STATE_FAILED_MOBILE,
	NETWORK_STATE_FAILED_VPN
} NetworkState;

struct _NetworkVPNMenuItemPrivate {
	NMRemoteConnection* _connection;
	NetworkState _state;
	GtkRadioButton* radio_button;
	GtkSpinner* spinner;
	GtkImage* error_img;
	GtkButton* remove_button;
};


static gpointer network_vpn_menu_item_parent_class = NULL;

GType network_vpn_menu_item_get_type (void) G_GNUC_CONST;
GType network_state_get_type (void) G_GNUC_CONST;
#define NETWORK_VPN_MENU_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItemPrivate))
NetworkVPNMenuItem* network_vpn_menu_item_new (NMRemoteConnection* _connection, NetworkVPNMenuItem* previous);
NetworkVPNMenuItem* network_vpn_menu_item_construct (GType object_type, NMRemoteConnection* _connection, NetworkVPNMenuItem* previous);
static void __lambda27_ (NetworkVPNMenuItem* self);
NMRemoteConnection* network_vpn_menu_item_get_connection (NetworkVPNMenuItem* self);
static void ___lambda27__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void network_vpn_menu_item_update (NetworkVPNMenuItem* self);
static void _network_vpn_menu_item_update_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static gboolean __lambda28_ (NetworkVPNMenuItem* self, GtkWidget* b, GdkEventButton* ev);
static gboolean ___lambda28__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void _network_vpn_menu_item_update_nm_connection_changed (NMConnection* _sender, gpointer self);
NetworkVPNMenuItem* network_vpn_menu_item_new_blank (void);
NetworkVPNMenuItem* network_vpn_menu_item_construct_blank (GType object_type);
void network_vpn_menu_item_set_active (NetworkVPNMenuItem* self, gboolean active);
NetworkState network_vpn_menu_item_get_state (NetworkVPNMenuItem* self);
static void network_vpn_menu_item_show_item (NetworkVPNMenuItem* self, GtkWidget* w);
void network_vpn_menu_item_hide_icons (NetworkVPNMenuItem* self, gboolean show_remove_button);
static void network_vpn_menu_item_hide_item (NetworkVPNMenuItem* self, GtkWidget* w);
void network_vpn_menu_item_set_connection (NetworkVPNMenuItem* self, NMRemoteConnection* value);
void network_vpn_menu_item_set_state (NetworkVPNMenuItem* self, NetworkState value);
static void network_vpn_menu_item_finalize (GObject * obj);
static void _vala_network_vpn_menu_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_network_vpn_menu_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void __lambda27_ (NetworkVPNMenuItem* self) {
	GError * _inner_error_ = NULL;
	{
		NMRemoteConnection* _tmp0_;
		_tmp0_ = self->priv->_connection;
		nm_remote_connection_delete (_tmp0_, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch15_g_error;
		}
	}
	goto __finally15;
	__catch15_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_warning ("VPNMenuItem.vala:52: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally15:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda27__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	__lambda27_ ((NetworkVPNMenuItem*) self);
}


static void _network_vpn_menu_item_update_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	network_vpn_menu_item_update ((NetworkVPNMenuItem*) self);
}


static gboolean __lambda28_ (NetworkVPNMenuItem* self, GtkWidget* b, GdkEventButton* ev) {
	gboolean result = FALSE;
	g_return_val_if_fail (b != NULL, FALSE);
	g_return_val_if_fail (ev != NULL, FALSE);
	g_signal_emit (self, network_vpn_menu_item_signals[NETWORK_VPN_MENU_ITEM_USER_ACTION_SIGNAL], 0);
	result = FALSE;
	return result;
}


static gboolean ___lambda28__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = __lambda28_ ((NetworkVPNMenuItem*) self, _sender, event);
	return result;
}


static void _network_vpn_menu_item_update_nm_connection_changed (NMConnection* _sender, gpointer self) {
	network_vpn_menu_item_update ((NetworkVPNMenuItem*) self);
}


NetworkVPNMenuItem* network_vpn_menu_item_construct (GType object_type, NMRemoteConnection* _connection, NetworkVPNMenuItem* previous) {
	NetworkVPNMenuItem * self = NULL;
	NMRemoteConnection* _tmp0_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkRadioButton* _tmp4_;
	NetworkVPNMenuItem* _tmp5_;
	GtkImage* _tmp10_;
	GtkImage* _tmp11_;
	GtkSpinner* _tmp12_;
	GtkSpinner* _tmp13_;
	GtkSpinner* _tmp14_;
	GtkSpinner* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	GtkButton* _tmp18_;
	GtkButton* _tmp19_;
	GtkStyleContext* _tmp20_;
	GtkButton* _tmp21_;
	GtkBox* _tmp22_;
	GtkRadioButton* _tmp23_;
	GtkBox* _tmp24_;
	GtkSpinner* _tmp25_;
	GtkBox* _tmp26_;
	GtkImage* _tmp27_;
	GtkBox* _tmp28_;
	GtkButton* _tmp29_;
	GtkBox* _tmp30_;
	GtkStyleContext* _tmp31_;
	GtkRadioButton* _tmp32_;
	GtkRadioButton* _tmp33_;
	NMRemoteConnection* _tmp34_;
	g_return_val_if_fail (_connection != NULL, NULL);
	_tmp0_ = _connection;
	self = (NetworkVPNMenuItem*) g_object_new (object_type, "connection", _tmp0_, NULL);
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
	g_object_ref_sink (_tmp1_);
	main_box = _tmp1_;
	_tmp2_ = main_box;
	_tmp3_ = main_box;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp3_, 6);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp2_, 6);
	_tmp4_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->radio_button);
	self->priv->radio_button = _tmp4_;
	_tmp5_ = previous;
	if (_tmp5_ != NULL) {
		GtkRadioButton* _tmp6_;
		NetworkVPNMenuItem* _tmp7_;
		GtkRadioButton* _tmp8_;
		GSList* _tmp9_;
		_tmp6_ = self->priv->radio_button;
		_tmp7_ = previous;
		_tmp8_ = _tmp7_->priv->radio_button;
		_tmp9_ = gtk_radio_button_get_group (_tmp8_);
		gtk_radio_button_set_group (_tmp6_, _tmp9_);
	}
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name ("process-error-symbolic", GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->error_img);
	self->priv->error_img = _tmp10_;
	_tmp11_ = self->priv->error_img;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp11_, _ ("This Virtual Private Network could not be connected to."));
	_tmp12_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->priv->spinner);
	self->priv->spinner = _tmp12_;
	_tmp13_ = self->priv->spinner;
	gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
	_tmp14_ = self->priv->spinner;
	_tmp15_ = self->priv->spinner;
	_tmp16_ = gtk_widget_get_visible ((GtkWidget*) _tmp15_);
	_tmp17_ = _tmp16_;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp14_, !_tmp17_);
	_tmp18_ = (GtkButton*) gtk_button_new_from_icon_name ("user-trash-symbolic", GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp18_);
	_g_object_unref0 (self->priv->remove_button);
	self->priv->remove_button = _tmp18_;
	_tmp19_ = self->priv->remove_button;
	_tmp20_ = gtk_widget_get_style_context ((GtkWidget*) _tmp19_);
	gtk_style_context_add_class (_tmp20_, "flat");
	_tmp21_ = self->priv->remove_button;
	g_signal_connect_object (_tmp21_, "clicked", (GCallback) ___lambda27__gtk_button_clicked, self, 0);
	_tmp22_ = main_box;
	_tmp23_ = self->priv->radio_button;
	gtk_box_pack_start (_tmp22_, (GtkWidget*) _tmp23_, TRUE, TRUE, (guint) 0);
	_tmp24_ = main_box;
	_tmp25_ = self->priv->spinner;
	gtk_box_pack_start (_tmp24_, (GtkWidget*) _tmp25_, FALSE, FALSE, (guint) 0);
	_tmp26_ = main_box;
	_tmp27_ = self->priv->error_img;
	gtk_box_pack_start (_tmp26_, (GtkWidget*) _tmp27_, FALSE, FALSE, (guint) 0);
	_tmp28_ = main_box;
	_tmp29_ = self->priv->remove_button;
	gtk_box_pack_start (_tmp28_, (GtkWidget*) _tmp29_, FALSE, FALSE, (guint) 0);
	_tmp30_ = main_box;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp30_);
	_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp31_, "menuitem");
	g_signal_connect_object ((GObject*) self, "notify::state", (GCallback) _network_vpn_menu_item_update_g_object_notify, self, 0);
	_tmp32_ = self->priv->radio_button;
	g_signal_connect_object ((GObject*) _tmp32_, "notify::active", (GCallback) _network_vpn_menu_item_update_g_object_notify, self, 0);
	_tmp33_ = self->priv->radio_button;
	g_signal_connect_object ((GtkWidget*) _tmp33_, "button-release-event", (GCallback) ___lambda28__gtk_widget_button_release_event, self, 0);
	_tmp34_ = self->priv->_connection;
	g_signal_connect_object ((NMConnection*) _tmp34_, "changed", (GCallback) _network_vpn_menu_item_update_nm_connection_changed, self, 0);
	network_vpn_menu_item_update (self);
	_g_object_unref0 (main_box);
	return self;
}


NetworkVPNMenuItem* network_vpn_menu_item_new (NMRemoteConnection* _connection, NetworkVPNMenuItem* previous) {
	return network_vpn_menu_item_construct (NETWORK_TYPE_VPN_MENU_ITEM, _connection, previous);
}


/**
     * Only used for an item which is not displayed: hacky way to have no radio button selected.
     **/
NetworkVPNMenuItem* network_vpn_menu_item_construct_blank (GType object_type) {
	NetworkVPNMenuItem * self = NULL;
	GtkRadioButton* _tmp0_;
	self = (NetworkVPNMenuItem*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->radio_button);
	self->priv->radio_button = _tmp0_;
	return self;
}


NetworkVPNMenuItem* network_vpn_menu_item_new_blank (void) {
	return network_vpn_menu_item_construct_blank (NETWORK_TYPE_VPN_MENU_ITEM);
}


void network_vpn_menu_item_set_active (NetworkVPNMenuItem* self, gboolean active) {
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->radio_button;
	_tmp1_ = active;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp1_);
}


static void network_vpn_menu_item_update (NetworkVPNMenuItem* self) {
	GtkRadioButton* _tmp0_;
	NMRemoteConnection* _tmp1_;
	const gchar* _tmp2_;
	NetworkState _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->radio_button;
	_tmp1_ = self->priv->_connection;
	_tmp2_ = nm_connection_get_id ((NMConnection*) _tmp1_);
	gtk_button_set_label ((GtkButton*) _tmp0_, _tmp2_);
	_tmp3_ = self->priv->_state;
	switch (_tmp3_) {
		case NETWORK_STATE_FAILED_VPN:
		{
			GtkImage* _tmp4_;
			_tmp4_ = self->priv->error_img;
			network_vpn_menu_item_show_item (self, (GtkWidget*) _tmp4_);
			break;
		}
		case NETWORK_STATE_CONNECTING_VPN:
		{
			GtkSpinner* _tmp5_;
			_tmp5_ = self->priv->spinner;
			network_vpn_menu_item_show_item (self, (GtkWidget*) _tmp5_);
			break;
		}
		default:
		{
			network_vpn_menu_item_hide_icons (self, TRUE);
			break;
		}
	}
}


void network_vpn_menu_item_hide_icons (NetworkVPNMenuItem* self, gboolean show_remove_button) {
	GtkImage* _tmp0_;
	GtkSpinner* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->error_img;
	network_vpn_menu_item_hide_item (self, (GtkWidget*) _tmp0_);
	_tmp1_ = self->priv->spinner;
	network_vpn_menu_item_hide_item (self, (GtkWidget*) _tmp1_);
	_tmp2_ = show_remove_button;
	if (!_tmp2_) {
		GtkButton* _tmp3_;
		_tmp3_ = self->priv->remove_button;
		network_vpn_menu_item_hide_item (self, (GtkWidget*) _tmp3_);
	}
}


static void network_vpn_menu_item_show_item (NetworkVPNMenuItem* self, GtkWidget* w) {
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (w != NULL);
	_tmp0_ = w;
	gtk_widget_set_visible (_tmp0_, TRUE);
	_tmp1_ = w;
	_tmp2_ = w;
	_tmp3_ = gtk_widget_get_visible (_tmp2_);
	_tmp4_ = _tmp3_;
	gtk_widget_set_no_show_all (_tmp1_, !_tmp4_);
}


static void network_vpn_menu_item_hide_item (NetworkVPNMenuItem* self, GtkWidget* w) {
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkWidget* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (w != NULL);
	_tmp0_ = w;
	gtk_widget_set_visible (_tmp0_, FALSE);
	_tmp1_ = w;
	_tmp2_ = w;
	_tmp3_ = gtk_widget_get_visible (_tmp2_);
	_tmp4_ = _tmp3_;
	gtk_widget_set_no_show_all (_tmp1_, !_tmp4_);
	_tmp5_ = w;
	gtk_widget_hide (_tmp5_);
}


NMRemoteConnection* network_vpn_menu_item_get_connection (NetworkVPNMenuItem* self) {
	NMRemoteConnection* result;
	NMRemoteConnection* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_connection;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void network_vpn_menu_item_set_connection (NetworkVPNMenuItem* self, NMRemoteConnection* value) {
	g_return_if_fail (self != NULL);
	if (network_vpn_menu_item_get_connection (self) != value) {
		NMRemoteConnection* _tmp0_;
		NMRemoteConnection* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_connection);
		self->priv->_connection = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY]);
	}
}


NetworkState network_vpn_menu_item_get_state (NetworkVPNMenuItem* self) {
	NetworkState result;
	NetworkState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}


void network_vpn_menu_item_set_state (NetworkVPNMenuItem* self, NetworkState value) {
	g_return_if_fail (self != NULL);
	if (network_vpn_menu_item_get_state (self) != value) {
		NetworkState _tmp0_;
		_tmp0_ = value;
		self->priv->_state = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_STATE_PROPERTY]);
	}
}


static void network_vpn_menu_item_class_init (NetworkVPNMenuItemClass * klass) {
	network_vpn_menu_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NetworkVPNMenuItemPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_network_vpn_menu_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_vpn_menu_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = network_vpn_menu_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY] = g_param_spec_object ("connection", "connection", "connection", nm_remote_connection_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_STATE_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", NETWORK_TYPE_STATE, NETWORK_STATE_DISCONNECTED, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	network_vpn_menu_item_signals[NETWORK_VPN_MENU_ITEM_USER_ACTION_SIGNAL] = g_signal_new ("user-action", NETWORK_TYPE_VPN_MENU_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void network_vpn_menu_item_instance_init (NetworkVPNMenuItem * self) {
	self->priv = NETWORK_VPN_MENU_ITEM_GET_PRIVATE (self);
	self->priv->_state = NETWORK_STATE_DISCONNECTED;
}


static void network_vpn_menu_item_finalize (GObject * obj) {
	NetworkVPNMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem);
	_g_object_unref0 (self->priv->_connection);
	_g_object_unref0 (self->priv->radio_button);
	_g_object_unref0 (self->priv->spinner);
	_g_object_unref0 (self->priv->error_img);
	_g_object_unref0 (self->priv->remove_button);
	G_OBJECT_CLASS (network_vpn_menu_item_parent_class)->finalize (obj);
}


GType network_vpn_menu_item_get_type (void) {
	static volatile gsize network_vpn_menu_item_type_id__volatile = 0;
	if (g_once_init_enter (&network_vpn_menu_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetworkVPNMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_vpn_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkVPNMenuItem), 0, (GInstanceInitFunc) network_vpn_menu_item_instance_init, NULL };
		GType network_vpn_menu_item_type_id;
		network_vpn_menu_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkVPNMenuItem", &g_define_type_info, 0);
		g_once_init_leave (&network_vpn_menu_item_type_id__volatile, network_vpn_menu_item_type_id);
	}
	return network_vpn_menu_item_type_id__volatile;
}


static void _vala_network_vpn_menu_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NetworkVPNMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem);
	switch (property_id) {
		case NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY:
		g_value_set_object (value, network_vpn_menu_item_get_connection (self));
		break;
		case NETWORK_VPN_MENU_ITEM_STATE_PROPERTY:
		g_value_set_enum (value, network_vpn_menu_item_get_state (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_network_vpn_menu_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NetworkVPNMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem);
	switch (property_id) {
		case NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY:
		network_vpn_menu_item_set_connection (self, g_value_get_object (value));
		break;
		case NETWORK_VPN_MENU_ITEM_STATE_PROPERTY:
		network_vpn_menu_item_set_state (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



